function bench()
%BENCH Summary of this function goes here
%  Detailed explanation goes here

% Connect to the "EpicsCAClient" ActiveX Automation Server,
% create a "ProcessVariable" on there:
pv = actxserver('EpicsCAClient.ProcessVariable');

% 'alan' is an array served by excas (100 double entries)
pv.name = 'Test_LLRF:HPM1:HB0';

% The EpicsCAClient.Processvariable sends an ActiveX Event when the connection
% status and/or value changes.
% In Visual Basic we would prepare to catch the "Changed" event and spend our
% time doing something useful until we receive the "Changed" event.
% But Matlab cannot handle events for ActiveX _servers_ (only "controls").
% So all we can do is sit in a busy wait loop until the connection comes up.
% If the PV doesn't exist, we will be stuck in here forever....
while pv.is_connected == 0,
    pause(1);
end

i=0;
secs=20;
start=cputime;
stop=cputime+secs;
% Remove flicker
set(gcf, 'DoubleBuffer', 'on');
% Save some memory
set(gcf, 'BackingStore', 'off');
%set(gcf, 'Renderer', 'OpenGL');
x=1:length(pv.value);
lh=plot(x, double(pv.value));
while cputime < stop
    set(lh, 'YData', double(pv.value));
    drawnow;
    i=i+1;
end

fprintf(1, 'Redraws per sec: %g\n', i/secs);

% Ask the EpicsCAServer to remove out ProcessVariable.
% It will disconnect from ChannelAccess, the 'pv' is useless from now on:
delete(pv);

