VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Epics CA Client Library Test"
   ClientHeight    =   3768
   ClientLeft      =   48
   ClientTop       =   336
   ClientWidth     =   5400
   Icon            =   "SimpleClient.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   3768
   ScaleWidth      =   5400
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdGet 
      Caption         =   "&Get"
      Height          =   375
      Left            =   3960
      TabIndex        =   5
      Top             =   600
      Width           =   615
   End
   Begin VB.CommandButton cmdSet 
      Caption         =   "&Set"
      Height          =   375
      Left            =   4680
      TabIndex        =   6
      Top             =   600
      Width           =   615
   End
   Begin VB.TextBox txtValue 
      Height          =   285
      Left            =   960
      TabIndex        =   4
      Text            =   "0"
      Top             =   600
      Width           =   1455
   End
   Begin VB.TextBox txtPVName 
      Height          =   285
      Left            =   960
      TabIndex        =   1
      Text            =   "DoublePV"
      ToolTipText     =   "Enter the Epics Process Variable's Name"
      Top             =   120
      Width           =   2895
   End
   Begin VB.ListBox lstInfo 
      Height          =   2544
      Left            =   120
      TabIndex        =   7
      ToolTipText     =   "Information on conenction, values and stuff"
      Top             =   1080
      Width           =   5175
   End
   Begin VB.CommandButton cmdConnect 
      Caption         =   "&Connect"
      Height          =   375
      Left            =   3960
      TabIndex        =   2
      ToolTipText     =   "Connect to PV"
      Top             =   120
      Width           =   1335
   End
   Begin VB.Label Label2 
      AutoSize        =   -1  'True
      Caption         =   "&New Value:"
      Height          =   192
      Left            =   120
      TabIndex        =   3
      Top             =   600
      Width           =   828
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "&PV Name:"
      Height          =   312
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   720
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim WithEvents PV As EpicsCAClient.ProcessVariable
Attribute PV.VB_VarHelpID = -1
Dim have_connection As Boolean

Private Sub Form_Activate()
    txtPVName.SetFocus
    cmdGet.Enabled = False
    cmdSet.Enabled = False
    have_connection = False
End Sub

Private Sub Form_Unload(Cancel As Integer)
    ' Joen Connell: assert removal from memory
    Set frmMain = Nothing
End Sub

Private Sub cmdConnect_Click()
    Screen.MousePointer = vbHourglass
    
    ' A PV cannot change its name.
    ' We can delete the PV, though, and create a new one.
    Set PV = New EpicsCAClient.ProcessVariable
    have_connection = False

    PV.Name = txtPVName
    lstInfo.AddItem "PV name: " & PV.Name
    ' Wait for connection event...
End Sub

' Manual CA 'get'
Private Sub cmdGet_Click()
    ' Simulate event to display the new value:
    PV_NewValue 1, PV.value
End Sub

' Manual CA 'put'
Private Sub cmdSet_Click()
    PV.value = txtValue
End Sub

Private Sub PV_NewValue(ByVal is_connected As Long, ByVal value As Variant)
    Dim line As String, i As Integer
    
    If is_connected > 0 Then
        If Not have_connection Then
            have_connection = True
            cmdGet.Enabled = True
            cmdSet.Enabled = True
            Screen.MousePointer = vbDefault
        End If
        ' Response to 'new value' event of PV:
        ' Display the value!
        If IsArray(value) Then
            line = "["
            For i = LBound(value) To UBound(value) - 1
                line = line & value(i) & ","
            Next i
            line = line & value(UBound(value)) & "]"
        Else
            line = value
        End If
        lstInfo.AddItem PV.Name & " = " & line
        lstInfo.ListIndex = lstInfo.ListCount - 1
    Else
        lstInfo.AddItem PV.Name & " disconnected"
        Screen.MousePointer = vbHourglass
        have_connection = False
    End If
End Sub

Private Sub txtPVName_GotFocus()
    SelectAll
End Sub

Private Sub txtValue_GotFocus()
    SelectAll
End Sub

