% Demo of serving one value via EpicsCAServer
%

clear all;

pv = actxserver('EpicsCAServer.ProcessVariable');

% List all properties:
get(pv)

% Set some properties, name being the essential one:
pv.name = 'egon';
pv.graphic_high = 10;
pv.graphic_low = -10;

% List all methods:
invoke(pv)

% Set the value
value = pi;
va = invoke(pv, 'SetValue', value);
% From now on, CA clients can see the PV!

% Change the value, monitorring clients will receive update:
va = invoke(pv, 'SetValue', value+1);

delete(pv);
